import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.tomgibara.cluster.gvm.dbl.DblClusters;
import com.tomgibara.cluster.gvm.dbl.DblListKeyer;
import com.tomgibara.cluster.gvm.dbl.DblResult;

import Jama.EigenvalueDecomposition;
import Jama.Matrix;
import Jcg.io.options.ProcessInputParameters;


/**
 * This class provides input/output methods for testing (planar) drawing algorithms
 */
public class Nystrom {

	static ProcessInputParameters input; // for reading input parameters

	/**
	 * Test graph algorithms
	 * @throws Exception 
	 */
	
    @SuppressWarnings("null")
   
       

    public static void main(String[] args) throws Exception
    { 	
    	// get parameters
    	 ArrayList<String>param=getparameters(args[0]);
    	 String path = param.get(0);  int sizedataset = Integer.parseInt(param.get(1));	
    	 int kclust =Integer.parseInt(param.get(2)); //int iteration=Integer.parseInt(param.get(3));
    	 int numsimpl=Integer.parseInt(param.get(3)); int percentage=Integer.parseInt(param.get(4));
    	 String pathresult=param.get(5); 
    	//getdata 
    	double[][] gandS=Nystrom.getinputmatrix(path,sizedataset);     	 
    	//getsample
    	double[][] MVSS =Sampling.MSSS(gandS,numsimpl,percentage); 
    	//get the cluster
    	double[][] nystresult =onlinenystromspectralclustering(gandS, MVSS, kclust);
    	
    	 PrintWriter writer = new PrintWriter(pathresult, "UTF-8");
	 	 writer.println("data line"+","+"cluster");
	 	  for(int i=0; i< nystresult.length; i++)
          {	         
	 		  writer.println(nystresult[i][0] +","+nystresult[i][1]);
	 		 //System.out.println(nystresult[i][0] +","+nystresult[i][1]);
			  
          }
		  writer.close();
		System.out.println("End of the clustering task "); 
        System.out.println("The results are in the following path: "+param.get(5)); 
    	                     
   }
    
///////////////////////////getparameters/////////////////////
    public static ArrayList<String> getparameters( String parameters) throws Exception 
    	 {
    		 
    		// String parameters="C:/Users/PNWN9234/Desktop/Diapo/Developpement/MyAs/parameters.txt";
    		  ArrayList<Resultcluster> Clusterslist= new  ArrayList<Resultcluster>() ;
    		     		   
    		   boolean eof = false;
    	        String input;
    	        String output;
    		  String sentence= null;
    		  ArrayList<String> data= new ArrayList<String>();

    		 try {
    		        //  open up standard input
    		            Reader reader = new InputStreamReader(new FileInputStream(parameters),"UTF-8");
    		            BufferedReader br = new BufferedReader(reader);
    		            while (!eof) {
    		                input = br.readLine();
    		                if (input != null) {
    		                     String[] res=input.split("=");
    		                    // System.out.print("1:"+res[0]+"2:"+res[0]);
    		                     data.add(res[1]);
    		                } else {
    		                    eof = true;
    		                }
    		            }
    		            br.close();
    		        } catch (IOException ex) {
    		          System.out.print("Erreur lecture ligne fichier !!");
    		        }
    		 
    		/*  for(int j=0;j<data.size(); j++)
    		     {
    		     System.out.print(j + " parameters: " + data.get(j)); 
    		    }*/
    		return data;
    		 
    	 }
  
   
 ///////////////////////////////// online spectral clustering
    
    
    public static double[][] onlinenystromspectralclustering (double[][] gandSS, double[][] s, int numclust) throws Exception { 

        // create  list  	 
    	ArrayList<Double[]> listtab = new ArrayList<Double[]>(); 
    	
    	  for (int i=0; i<gandSS.length;i++) 
    	  { 	ArrayList<Double> listofsim = new ArrayList<Double>(); 
    		 int exist=0;
    		  for (int t=0; t<s.length;t++) 
    		  { 
    		   /* if( gandSS[i]==s[t]){  exist=1;  
    		                      System.out.println("exist");   
    		                        }*/ 			    
    		   if (Arrays.equals(gandSS[i], s[t])) {  exist=1;  
                             //   System.out.println("exist");   
                                                   } 		    
    		  }	  
    		  
    		  if(exist==0) 
    			{  for (int t=0; t<s.length;t++) 
    		  { 
    		   /* if( gandSS[i]==s[t]){  exist=1;  
    		                      System.out.println("exist");   
    		                        }*/ 			    
    		   if (Arrays.equals(gandSS[i], s[t])) {  exist=1;  
                                System.out.println("exist");   
                                                   } 		    
    		  }
    	     }
    		if(exist==0) 
    		{
    	     for (int j=0; j<s.length;j++) 
    		  {        
    			  Double value=Cosine.cosine_similarity(gandSS[i],s[j]);
    			  listofsim.add(value);				  		   
    		  }
    	
    	   Double[] vector = listofsim.toArray(new Double[listofsim.size()]);		   
    	   listtab.add(vector);
    		}
    	  }	
    	
    	  
    	 // System.out.println("listtab.size()"+listtab.size());
    	  Double[][] convert = new Double[listtab.size()][];
    	  for (int i = 0; i < convert.length; i++) 
    	       {
    		  convert[i] =  listtab.get(i); 
    		 
    	       }
    	  
    	  double[][] convertB = new double[convert.length][convert[0].length];
    	//  System.out.println(Arrays.deepToString(convert)); 
    	  
    	 // System.out.println(convertB.length);
    	    for (int i = 0; i < convertB.length; i++) 
    	    {    
    	    	// System.out.println("convert[i] ="+i);
    	    	for (int j = 0; j < convertB[i].length; j++) 
    	          {
    	    		convertB[i][j] = (double)convert[i][j];
    	    		//System.out.println("j="+j);
    	          }
    	    }
    	    
    	    Matrix B = new Matrix(convertB); 
    	 
    		//B.print(9, 6);
    	// strat clustering
    	 // create M-by-N matrix that doesn't have full rank
    	
    	Matrix simmatrix =getsimatrix(s);
    	
    	double[][] A =  simmatrix.getArray(); 
    	//System.out.println(" A.length: "+  A.length);
    	
    	// get diagonal matrix w
    	Matrix d = getdiagonal(A);  
    	Matrix w = new Matrix(A); 
    	

    	//get the laplacian matrix
    	Matrix l = d.minus(w);   	
        
    	//  Get the Eigen value decomposition
    	EigenvalueDecomposition eigen = l.eig();
    	//EigenvalueDecomposition eigen = w.eig();

    	Matrix ua = eigen.getV(); // get U_a
    	//ua.print(9, 6);
        //System.out.println(ua);
    	
    	Matrix landaa = eigen.getD(); // get landa_a^{-1} 
    	
    	
    	Matrix landaaminus1 = eigen.getD();
    	//landaa.print(9, 6);
        // System.out.println(landaa);
    	if (landaa.det() !=0) landaaminus1 = landaa.inverse();
    	//landaaminus1.print(9, 6);
        //System.out.println(landaaminus1);
        
    	//get BUalanda^-1a
    	Matrix ual1 =  ua.times(landaaminus1);     	
    	Matrix BUalanda = B.times(ual1);
    	//System.out.println(" array.length: "+  array.length);   	    	
    	
    	double[][] array=ua.getArray();
    	double[][] arrayBUal=BUalanda.getArray();
  	   	
    	//concatenate
    	double m[][] = new double[arrayBUal.length+array.length][];
   	
    	System.arraycopy(arrayBUal, 0, m, 0, arrayBUal.length);
    	System.arraycopy(array, 0, m, arrayBUal.length, array.length);
    	    	
    	 // get online clustering
       	 double[][] converted=onlineclustering(m,numclust);

    	 	return converted;  
    	                    
    }
    
    public static double[][] onlineclustering(double[][] pts,int capacity) throws IOException, InterruptedException {

    	ArrayList<double[]> listoftable = new ArrayList<double[]>();
       	ArrayList<Integer> listofhistory = new ArrayList<Integer>();
      	
      	//System.out.println(" size colmun: "+ pts[0].length);
           
            DblClusters<List<double[]>> clusters = new DblClusters<List<double[]>>(pts[0].length, capacity);
            clusters.setKeyer(new DblListKeyer<double[]>());
            for (double[] pt : pts) {
                    ArrayList<double[]> key = new ArrayList<double[]>();
                    key.add(pt);
                    clusters.add(1.0, pt, key);
            }
           
         //   FileWriter writer = new FileWriter("/home/dbouneffouf/Desktop/MainWork/Release/result-onlineclustered.txt");
            final List<DblResult<List<double[]>>> results = clusters.results();
            for (int i = 0; i < results.size(); i++) {
                    for (double[] pt : results.get(i).getKey()) {
                    	
                	 	int varligne= Nystrom.getline(pts,pt,listofhistory);
            			double[] tab = new double[] {varligne,i};
            		   // System.out.println(Arrays.toString(tab)); 
            		 	listoftable.add(tab);	
            			listofhistory.add(varligne);
                    	
                    	/*System.out.println(" size colmun: "+  Arrays.toString(pt)); 
                            writer.write(String.format("%3.3f %3.3f %d%n", pt[0], pt[1], i));*/
                    }
            }  
            
          	 double[][] converted = new double[listoftable.size()][];
     	    for (int i = 0; i < converted.length; i++) 
     	    	converted[i] = listoftable.get(i); 
            
     	    
     	   Arrays.sort(converted, new ColumnComparator(0,true));
   	   	

   	 	return converted;  
         //   writer.close();
    }
          
  //////////////////////////////////spectral clustering  
    public static double[][] nystromspectralclustering (double[][] gandSS, double[][] s, int kvar, int iteration) throws Exception { 

    // create  liste  	 
	ArrayList<Double[]> listtab = new ArrayList<Double[]>(); 
	
	  for (int i=0; i<gandSS.length;i++) 
	  { 	ArrayList<Double> listofsim = new ArrayList<Double>(); 
		 int exist=0;
		  for (int t=0; t<s.length;t++) 
		  { 
		    
		   if (Arrays.equals(gandSS[i], s[t])) {  exist=1;  
            
                                               } 		    
		  }	  
		  
		  if(exist==0) 
			{  for (int t=0; t<s.length;t++) 
		  { 
			    
		   if (Arrays.equals(gandSS[i], s[t])) {  exist=1;  
                            System.out.println("exist");   
                                               } 		    
		  }
	     }
		if(exist==0) 
		{
	     for (int j=0; j<s.length;j++) 
		  {        
			  Double value=Cosine.cosine_similarity(gandSS[i],s[j]);
			  listofsim.add(value);				  		   
		  }
	
	   Double[] vector = listofsim.toArray(new Double[listofsim.size()]);		   
	   listtab.add(vector);
		}
	  }	
	
	  
	  Double[][] convert = new Double[listtab.size()][];
	  for (int i = 0; i < convert.length; i++) 
	       {
		  convert[i] =  listtab.get(i); 
		 
	       }
	  
	  double[][] convertB = new double[convert.length][convert[0].length];

	    for (int i = 0; i < convertB.length; i++) 
	    {    

	    	for (int j = 0; j < convertB[i].length; j++) 
	          {
	    		convertB[i][j] = (double)convert[i][j];
	
	          }
	    }
	    
	    Matrix B = new Matrix(convertB); 
	 
		//B.print(9, 6);

	 // create M-by-N matrix that doesn't have full rank
	
	Matrix simmatrix =getsimatrix(s);
	
	double[][] A =  simmatrix.getArray(); 
	
	// get diagonal matrix w
	Matrix d = getdiagonal(A);  
	Matrix w = new Matrix(A); 
	

	//get the laplacian matrix
	//Matrix l = d.minus(w);   	
    
	//  Get the Eigen value decomposition
	EigenvalueDecomposition eigen = w.eig();

	Matrix ua = eigen.getV(); // get U_a
	//ua.print(9, 6);
	
	Matrix landaa = eigen.getD(); // get landa_a^{-1} 
	
	
	Matrix landaaminus1 = eigen.getD();
	//landaa.print(9, 6);

	if (landaa.det() !=0) landaaminus1 = landaa.inverse();
	//landaaminus1.print(9, 6);
    
	//get BUalanda^-1a
	Matrix ual1 =  ua.times(landaaminus1);     	
	Matrix BUalanda = B.times(ual1);
	//System.out.println(" array.length: "+  array.length);   	    	
	
	double[][] array=ua.getArray();
	double[][] arrayBUal=BUalanda.getArray();
	
	//	get transpose
	/*Matrix BUalandatranspose = BUalanda.transpose();
	double[][] arrayBUal=BUalandatranspose.getArray();
	
    Matrix uatranspose =ua.transpose();
	double[][] array=uatranspose.getArray();*/
	
	
	//concatenate
	double m[][] = new double[arrayBUal.length+array.length][];
	
	//System.out.println(" arrayBUal.length: "+  arrayBUal.length);
	//System.out.println(" array.length: "+  array.length);
	
	System.arraycopy(arrayBUal, 0, m, 0, arrayBUal.length);
	System.arraycopy(array, 0, m, arrayBUal.length, array.length);
    
 
    double startTime2 = System.currentTimeMillis();
	//start the k-mean clustering 
	kmeans k = new kmeans(m, kvar);
	
 
	
	k.calculateClusters(iteration);
	
	   double endTime2 = System.currentTimeMillis();
	   double totalTime2 = endTime2 - startTime2;
	   System.out.println("third step: "+totalTime2);
	   
	
	ArrayList<double[]> listoftable = new ArrayList<double[]>();
	ArrayList<Integer> listofhistory = new ArrayList<Integer>();
	
	 // System.out.println(" k.clusters.length: "+ k.clusters.length);
	 for (int c =0; c<k.clusters.length;c++) 
	 {    
		 for (int i =0; i<k.clusters[c].size();i++) 
		 { 			
		 	double[] elem = (double[])k.clusters[c].get(i); 
		 	int varligne= Nystrom.getline(m,elem, listofhistory);
			double[] tab = new double[] {varligne,c};
		// System.out.println(Arrays.toString(tab)); 
		 	listoftable.add(tab);	
			listofhistory.add(varligne);
				 	
		 }
	 }
	  System.out.println(" listoftable.size(): "+ listoftable.size());
	 
   	 double[][] converted = new double[listoftable.size()][];
	    for (int i = 0; i < converted.length; i++) 
	    	converted[i] = listoftable.get(i);  
	    
	   Arrays.sort(converted, new ColumnComparator(0,true));
	   

	 	return converted;  
	                    
}
       
      
    
 ////////////////////////////////////////  convert array in to matrix
   	public static Matrix arraytomatrix(double[][] s) { 
     
  	int colonlengh=s[0].length;  	
	int linelengh=s.length;
	Matrix A = new Matrix(linelengh,colonlengh);
	
	 for (int row = 0; row < linelengh; row++)
	 {			 
		 for (int l = 0; l < colonlengh; l++)
	     {
			double value =s [row][l]; 
			 A.set(row, l, value); 
	     } 
		     		 
	 }
	return A;
  }
        
    public static  double[][]  getinputmatrix (String path, int length) throws InterruptedException, IOException { 
    	    
    	ArrayList<double[]> listoftable = new ArrayList<double[]>();
    	
    	   BufferedReader br = new BufferedReader(new FileReader(path));
    	    try {
    	        StringBuilder sb = new StringBuilder();
    	       /* String line = br.readLine();
    	        System.out.println("length:   "+ length);*/ 
    	       for(int i = 0; i<length;i++)
    	        {
    	        String line = br.readLine();
    	       // System.out.println("line:   "+ i);
    	       // System.out.println("line.length():   "+ line.length()); 
    	        String[] tab = line.split(",");    	  
    	      //  System.out.println("tab[j]:   "+ tab[0]); 
    	        double[] intAry = new double[tab.length-1];  

    	        for (int j=0; j < intAry.length; j++) 
    	           {  
    	        	//System.out.println("tab[j]:   "+ tab[j]); 
    	              intAry[j] = Double.parseDouble(tab[j]);  
    	           }  
    	        listoftable.add(intAry);    	            
    	        }    	      
    	    } finally 
    	    {
    	        br.close();
    	    }
    	    
    	    double[][] converted = new double[listoftable.size()][];
    	    for (int i = 0; i < converted.length; i++) 
    	    	converted[i] = listoftable.get(i); 
    	    
    	  // System.out.println("converted[0][0]:   "+ converted[converted.length-1].length); 
    	   // System.out.println("converted[0][0]:   "+ converted[0][0]+"   converted[0][1]:    "+ converted[0][1]); 
    	    
    	    return converted;    	             	   	    	  	     	
    }    
    
           	
    public static Matrix getdiagonal(double[][] array){
    	//Initialize the identity matrix
        Matrix c = new Matrix(array.length,array.length);
        Matrix.identity(array.length, array.length);
    	
   	     //Construct the diagonal matrix        
    	 for (int row = 0; row < array.length; row++)
         {
    		 double total = 0; 
    		 for (int l = 0; l < array.length; l++)
             {
    			 total=total+array[row][l];
             }  
             c.set(row, row, total);   		     		 
         }    	 
        return c;
    }
    
    public static Matrix getsimatrix(double[][] s){

    	int colonlengh=s[0].length;
    	//System.out.println(s[0].length+"   ");
    	int linelengh=s.length;
    	Matrix simmat = new Matrix(linelengh,linelengh);
    	
    	 for (int row = 0; row < linelengh; row++)
    	 {
    		 double[] vec1 = new double[colonlengh]; 
    		 
    		 for (int l = 0; l < colonlengh; l++)
    	     {
    			 vec1[l] =s [row][l];    			  
    	     } 

    		 for (int l = 0; l < linelengh; l++)
    	     {   
    			 double[] vec2 = new double[colonlengh]; 			     			     			     			 
    			 for (int i = 0; i < colonlengh; i++)
    	         {       			     			 
    				vec2[i] =s [l][i]; 			  
    	         } 
    			 double cossim = Cosine.cosine_similarity(vec1,vec2);
    			 
    			 simmat.set(row, l, cossim); 
    	     } 
    		     		 
    	 }
    		/*System.out.println("display simatrix:");
    		simmat.print(8,4); 	 */
        return simmat;
    }
	
    public static int getline (double[][] s, double[] elem, ArrayList<Integer> listofhistory) throws InterruptedException    
    {  
    	int value = 88888888;
    	 for (int i=0; i<s.length;i++) 
    	 { 
    	// if(Cosine.cosine_similarity(elem,s[i])>0.9999999  && listofhistory.contains(i)== false) {value=i; break; }
    	 if(elem.equals(s[i])==true  && listofhistory.contains(i)== false) {value=i; break; }
     	
    	// System.out.print(" conis: "+ Cosine.cosine_similarity(elem,s[i])); 	
    	 //System.out.print(" s[i]: "+ Arrays.toString(s[i])+ " elem: "+ Arrays.toString(elem));         	 
    	 }
    	 
    	return  value ;  	
    } 	
   
    public static int getlinevH (double[][] s, double[] elem) throws InterruptedException    
    {  
    	int value = 999999999;
    	 for (int i=0; i<s.length;i++) 
    	 { 
    	 if(Cosine.cosine_similarity(elem,s[i])>0.9999999 ) {value=i;   break; }
    	//	System.out.print(" conis: "+ Cosine.cosine_similarity(elem,s[i]));         	 
    	 }    	     	    	   	    	    	
    	return  value ;  	
    } 

}
